import React from 'react';
import styled from 'styled-components';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}

var FlexAlign;
(function (FlexAlign) {
    FlexAlign["STRETCH"] = "stretch";
    FlexAlign["START"] = "start";
    FlexAlign["END"] = "end";
    FlexAlign["CENTER"] = "center";
    FlexAlign["BASELINE"] = "baseline";
})(FlexAlign || (FlexAlign = {}));
var alignItems = function (align) {
    if (align === void 0) { align = FlexAlign.STRETCH; }
    switch (align) {
        case FlexAlign.STRETCH:
            return 'stretch';
        case FlexAlign.START:
            return 'flex-start';
        case FlexAlign.END:
            return 'flex-end';
        case FlexAlign.CENTER:
            return 'center';
        case FlexAlign.BASELINE:
            return 'baseline';
        default:
            return null;
    }
};
var alignSelf = function (align) {
    if (align) {
        return alignItems(align);
    }
    return null;
};
var FlexAlign$1 = FlexAlign;

var FlexBasis;
(function (FlexBasis) {
    FlexBasis["AUTO"] = "auto";
    FlexBasis["CONTENT"] = "content";
})(FlexBasis || (FlexBasis = {}));
var flexBasis = function (basis) {
    if (basis === void 0) { basis = FlexBasis.AUTO; }
    return basis;
};
var FlexBasis$1 = FlexBasis;

var FlexDirection;
(function (FlexDirection) {
    FlexDirection["ROW"] = "row";
    FlexDirection["COLUMN"] = "column";
})(FlexDirection || (FlexDirection = {}));
var flexDirection = function (direction, row, column, reverse) {
    if (direction === void 0) { direction = FlexDirection.ROW; }
    if (row === void 0) { row = false; }
    if (column === void 0) { column = false; }
    if (reverse === void 0) { reverse = false; }
    var property = direction;
    if (row) {
        property = FlexDirection.ROW;
    }
    if (column) {
        property = FlexDirection.COLUMN;
    }
    switch (property) {
        case FlexDirection.ROW:
            return reverse ? 'row-reverse' : 'row';
        case FlexDirection.COLUMN:
            return reverse ? 'column-reverse' : 'column';
        default:
            return null;
    }
};
var FlexDirection$1 = FlexDirection;

var FlexJustify;
(function (FlexJustify) {
    FlexJustify["START"] = "start";
    FlexJustify["END"] = "end";
    FlexJustify["CENTER"] = "center";
    FlexJustify["SPACE_BETWEEN"] = "space-between";
    FlexJustify["SPACE_AROUND"] = "space-around";
    FlexJustify["SPACE_EVENLY"] = "space-evenly";
})(FlexJustify || (FlexJustify = {}));
var justifyContent = function (justify) {
    if (justify === void 0) { justify = FlexJustify.START; }
    switch (justify) {
        case FlexJustify.START:
            return 'flex-start';
        case FlexJustify.END:
            return 'flex-end';
        case FlexJustify.CENTER:
            return 'center';
        case FlexJustify.SPACE_BETWEEN:
            return 'space-between';
        case FlexJustify.SPACE_AROUND:
            return 'space-around';
        case FlexJustify.SPACE_EVENLY:
            return 'space-evenly';
        default:
            return null;
    }
};
var FlexJustify$1 = FlexJustify;

var FlexLineAlign;
(function (FlexLineAlign) {
    FlexLineAlign["STRETCH"] = "stretch";
    FlexLineAlign["START"] = "start";
    FlexLineAlign["END"] = "end";
    FlexLineAlign["CENTER"] = "center";
    FlexLineAlign["SPACE_BETWEEN"] = "space-between";
    FlexLineAlign["SPACE_AROUND"] = "space-around";
    FlexLineAlign["SPACE_EVENLY"] = "space-evenly";
})(FlexLineAlign || (FlexLineAlign = {}));
var alignContent = function (align) {
    if (align === void 0) { align = FlexLineAlign.STRETCH; }
    switch (align) {
        case FlexLineAlign.STRETCH:
            return 'stretch';
        case FlexLineAlign.START:
            return 'flex-start';
        case FlexLineAlign.END:
            return 'flex-end';
        case FlexLineAlign.CENTER:
            return 'center';
        case FlexLineAlign.SPACE_BETWEEN:
            return 'space-between';
        case FlexLineAlign.SPACE_AROUND:
            return 'space-around';
        case FlexLineAlign.SPACE_EVENLY:
            return 'space-evenly';
        default:
            return null;
    }
};
var FlexLineAlign$1 = FlexLineAlign;

var FlexWrap;
(function (FlexWrap) {
    FlexWrap["REVERSE"] = "reverse";
})(FlexWrap || (FlexWrap = {}));
var flexWrap = function (wrap) {
    if (wrap === void 0) { wrap = false; }
    switch (typeof wrap) {
        case 'boolean':
            return wrap ? 'wrap' : 'nowrap';
        case 'string':
            if (wrap === FlexWrap.REVERSE) {
                return 'wrap-reverse';
            }
            return null;
        default:
            return null;
    }
};
var FlexWrap$1 = FlexWrap;

var flexGrow = function (grow) {
    if (grow === void 0) { grow = 0; }
    switch (typeof grow) {
        case 'boolean':
            return grow ? 1 : 0;
        case 'number':
            return grow;
        default:
            return 0;
    }
};
var flexShrink = function (shrink) {
    if (shrink === void 0) { shrink = 0; }
    switch (typeof shrink) {
        case 'boolean':
            return shrink ? 1 : 0;
        case 'number':
            return shrink;
        default:
            return 0;
    }
};
var FlexComponent = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  // flex\n  display: ", ";\n  flex-direction: ", ";\n  justify-content: ", ";\n  align-items: ", ";\n  align-content: ", ";\n  flex-wrap: ", ";\n  // flex-item\n  align-self: ", ";\n  order: ", ";\n  flex-grow: ", ";\n  flex-shrink: ", ";\n  flex-basis: ", ";\n"], ["\n  // flex\n  display: ", ";\n  flex-direction: ", ";\n  justify-content: ", ";\n  align-items: ", ";\n  align-content: ", ";\n  flex-wrap: ", ";\n  // flex-item\n  align-self: ", ";\n  order: ", ";\n  flex-grow: ", ";\n  flex-shrink: ", ";\n  flex-basis: ", ";\n"])), function (p) { return (p.inline ? 'inline-flex' : 'flex'); }, function (p) { return flexDirection(p.direction, p.row, p.column, p.reverse); }, function (p) { return justifyContent(p.justify); }, function (p) { return alignItems(p.align); }, function (p) { return alignContent(p.lines); }, function (p) { return flexWrap(p.wrap); }, function (p) { return alignSelf(p.alignSelf); }, function (p) { return p.order; }, function (p) { return flexGrow(p.grow); }, function (p) { return flexShrink(p.shrink); }, function (p) { return flexBasis(p.basis); });
var Flex = function (props) {
    var _a = props.as, as = _a === void 0 ? 'div' : _a, otherProps = __rest(props, ["as"]);
    return React.createElement(FlexComponent, __assign({ as: as }, otherProps));
};
var templateObject_1;

var index = {
    Flex: Flex,
    FlexAlign: FlexAlign$1,
    FlexBasis: FlexBasis$1,
    FlexDirection: FlexDirection$1,
    FlexJustify: FlexJustify$1,
    FlexLineAlign: FlexLineAlign$1,
    FlexWrap: FlexWrap$1
};

export default index;
