import React from 'react';
import FlexAlign from '../properties/FlexAlign';
import FlexBasis from '../properties/FlexBasis';
import FlexDirection from '../properties/FlexDirection';
import FlexJustify from '../properties/FlexJustify';
import FlexLineAlign from '../properties/FlexLineAlign';
import FlexWrap from '../properties/FlexWrap';
export declare type FlexProps<P> = P & {
    as?: keyof JSX.IntrinsicElements | React.ComponentType<any>;
    className?: string;
    style?: object;
    inline?: boolean;
    direction?: FlexDirection;
    row?: boolean;
    column?: boolean;
    reverse?: boolean;
    justify?: FlexJustify;
    align?: FlexAlign;
    lines?: FlexLineAlign;
    wrap?: boolean | FlexWrap;
    alignSelf?: FlexAlign;
    order?: number;
    grow?: boolean | number;
    shrink?: boolean | number;
    basis?: FlexBasis;
};
declare const Flex: <P extends {}>(props: FlexProps<P>) => JSX.Element;
export default Flex;
